package ru.micord.ervu.security.esia.model;

import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;

/**
 * Данные HTML-формы для POST с Content-Type=application/x-www-form-urlencoded.
 */
public class FormUrlencoded {

  // todo: private final Map<String, List<String>> ...
  private final Map<String, String> formData = new HashMap<>();

  /**
   * Устанавливает параметр в форму.
   */
  public FormUrlencoded setParameter(String name, String value) {
    if (name != null) formData.put(name, value);
    return this;
  }

  /**
   * Собирает из формы и возвращает строку в виде application/x-www-form-urlencoded.
   */
  public String toFormUrlencodedString() {
    final StringBuilder sb = new StringBuilder();
    formData.forEach((key, value) -> {
      if (key != null) key = URLEncoder.encode(key, StandardCharsets.UTF_8);
      if (value != null) value = URLEncoder.encode(value, StandardCharsets.UTF_8);
      if (sb.length() > 0) sb.append("&");
      sb.append(key).append("=").append(value);
    });
    return sb.toString();
  }

  @Override
  public String toString() {
    return toFormUrlencodedString();
  }
}
